DROP TABLE OTHERS;
DROP TABLE A CASCADE CONSTRAINTS;
DROP TABLE B CASCADE CONSTRAINTS;
DROP TABLE C CASCADE CONSTRAINTS;
DROP TABLE D CASCADE CONSTRAINTS;
DROP TABLE E CASCADE CONSTRAINTS;
DROP TABLE F CASCADE CONSTRAINTS;

CREATE TABLE OTHERS (
	OTHER_INT INT NULL ,
	OTHER_LONG NUMBER NULL ,
	OTHER_BIT SMALLINT DEFAULT 0 NOT NULL,
	OTHER_STRING VARCHAR2(32) NOT NULL
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

CREATE TABLE F (
	ID	VARCHAR2(50) NOT NULL ,
	F_LIBELLE VARCHAR2(50) NULL ,
	CONSTRAINT PK_F PRIMARY KEY (ID)
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

CREATE TABLE E (
	ID	VARCHAR2(50) NOT NULL ,
	E_LIBELLE VARCHAR2(50) NULL ,
	CONSTRAINT PK_E PRIMARY KEY (ID)
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

CREATE TABLE D (
	ID	VARCHAR2(50) NOT NULL ,
	D_LIBELLE VARCHAR2(50) NULL ,
	CONSTRAINT PK_D PRIMARY KEY (ID)
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

CREATE TABLE C (
	ID	VARCHAR2(50) NOT NULL ,
	C_LIBELLE VARCHAR2(50) NULL ,
	CONSTRAINT PK_C PRIMARY KEY (ID)
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

CREATE TABLE B (
	ID VARCHAR2(50) NOT NULL ,
	C_ID VARCHAR2(50) NULL ,
	D_ID VARCHAR2(50) NULL ,
	B_LIBELLE VARCHAR2(50) NULL ,
	CONSTRAINT PK_B PRIMARY KEY (ID)
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

ALTER TABLE B
  ADD CONSTRAINT FK_B_C
    FOREIGN KEY (C_ID)
    REFERENCES C (ID);

ALTER TABLE B
  ADD CONSTRAINT FK_B_D
    FOREIGN KEY (D_ID)
    REFERENCES D (ID);    
    
CREATE TABLE A (
	ID VARCHAR2(50) NOT NULL ,
	B_ID VARCHAR2(50)  NULL ,
	E_ID VARCHAR2(50)  NULL ,
	F_ID VARCHAR2(50)  NULL ,
	A_LIBELLE VARCHAR2(50) NULL ,
	CONSTRAINT PK_A PRIMARY KEY (ID)
)
NOLOGGING 
NOCACHE 
NOPARALLEL;

ALTER TABLE A
  ADD CONSTRAINT FK_A_B
    FOREIGN KEY (B_ID)
    REFERENCES B (ID);

ALTER TABLE A
  ADD CONSTRAINT FK_A_E
    FOREIGN KEY (E_ID)
    REFERENCES E (ID);    

ALTER TABLE A
  ADD CONSTRAINT FK_A_F
    FOREIGN KEY (F_ID)
    REFERENCES F (ID);    

INSERT INTO OTHERS VALUES(1, 8888888, 0, 'Oui');
INSERT INTO OTHERS VALUES(2, 9999999999, 1, 'Non');

INSERT INTO F VALUES('f', 'fff');
INSERT INTO E VALUES('e', 'eee');
INSERT INTO D VALUES('d', 'ddd');
INSERT INTO C VALUES('c', 'ccc');
INSERT INTO B VALUES('b', 'c', NULL, 'bbb');
INSERT INTO A VALUES('a', 'b', 'e', NULL, 'aaa');